<%@ Control language="vb" Inherits="WillStrohl.Modules.SimpleRedirect.Details" AutoEventWireup="false" Explicit="True" Codebehind="Details.ascx.vb" %>
<%@ Import Namespace="DotNetNuke.Services.Localization" %>
<%@ Register TagPrefix="dnn" TagName="Label" Src="~/controls/LabelControl.ascx" %>
<%@ Register TagPrefix="dnnweb" Assembly="DotNetNuke.Web" Namespace="DotNetNuke.Web.UI.WebControls" %>
<asp:Panel ID="pnlNoDetails" runat="server" CssClass="wnsRedirectNoDetails dnnClear">
    <div class="dnnFormMessage dnnFormInfo"><%=GetLocalizedString("NoDetails.Text")%></div>
    <div class="dnnClear">
        <asp:LinkButton ID="lnkEnable" runat="server" CssClass="dnnPrimaryAction" CausesValidation="False" />
    </div>
</asp:Panel>
<asp:Panel ID="pnlDetails" runat="server" CssClass="wnsRedirectDetails dnnClear">
    <div id="divRedirectHeader" class="dnnForm dnnEditEntry dnnClear">
        <fieldset id="fsHeader" class="wns-fieldset">
            <div class="dnnFormItem">
                <dnn:Label id="lblRedirect" runat="server" ResourceKey="lblRedirect" ControlName="txtRedirect" suffix=":" />
                <asp:TextBox ID="txtRedirect" runat="server" ReadOnly="True" CssClass="NormalTextBox wnsBlendedField" />
            </div>
            <div class="dnnFormItem">
                <dnn:Label id="lblHits" runat="server" ResourceKey="lblHits" ControlName="txtHits" suffix=":" />
                <asp:TextBox ID="txtHits" runat="server" ReadOnly="True" CssClass="NormalTextBox wnsBlendedField" />
            </div>
        </fieldset>
    </div>
    <div id="divRedirectDetails" class="dnnClear">
        <div class="dnnLeft">
            <asp:Repeater ID="rptUrls" runat="server">
                <HeaderTemplate>
                    <table id="tblUrls" class="dnnGrid">
                        <tr>
                            <td class="dnnGridHeader"><%=GetLocalizedString("Header.Url")%></td>
                        </tr>
                </HeaderTemplate>
                <ItemTemplate>
                    <tr>
                        <td class="dnnGridItem"><%#ReformatUrlForLink(Container.DataItem)%></td>
                    </tr>
                </ItemTemplate>
                <AlternatingItemTemplate>
                    <tr>
                        <td class="dnnGridAltItem"><%#ReformatUrlForLink(Container.DataItem)%></td>
                    </tr>
                </AlternatingItemTemplate>
                <FooterTemplate>
                    </table>
                </FooterTemplate>
            </asp:Repeater>
        </div>
        <div class="dnnRight">
            <asp:Repeater ID="rptDomain" runat="server">
                <HeaderTemplate>
                    <table id="tblDomains" class="dnnGrid">
                        <tr>
                            <td class="dnnGridHeader"><%=GetLocalizedString("Header.Domain")%></td>
                        </tr>
                </HeaderTemplate>
                <ItemTemplate>
                    <tr>
                        <td class="dnnGridItem"><%#ReformatDomainForLink(Container.DataItem)%></td>
                    </tr>
                </ItemTemplate>
                <AlternatingItemTemplate>
                    <tr>
                        <td class="dnnGridAltItem"><%#ReformatDomainForLink(Container.DataItem)%></td>
                    </tr>
                </AlternatingItemTemplate>
                <FooterTemplate>
                    </table>
                </FooterTemplate>
            </asp:Repeater>
        </div>
    </div>
    <div id="divRedirectActions" class="dnnClear">
        <a id="lnkReturn" href="<%=EditRedirectsUrl %>" class="dnnPrimaryAction"><%= GetLocalizedString("lnkReturn.Text") %></a> 
        <asp:LinkButton ID="lnkClearHistory" runat="server" CssClass="dnnSecondaryAction" CausesValidation="False" /> 
        <asp:LinkButton ID="lnkClose" runat="server" CssClass="dnnSecondaryAction" CausesValidation="False" /> 
    </div>
    <script language="javascript" type="text/javascript">/*<![CDATA[*/
        (function ($, Sys) {
            function setupDnnSiteSettings() {
                $('#<%= lnkClearHistory.ClientID %>').dnnConfirm({
                    text: '<%= GetLocalizedString("ClearLog.Text") %>',
                    yesText: '<%= Localization.GetString("Yes.Text", Localization.SharedResourceFile) %>',
                    noText: '<%= Localization.GetString("No.Text", Localization.SharedResourceFile) %>',
                    title: '<%= Localization.GetString("Confirm.Text", Localization.SharedResourceFile) %>'
                });
            }

            $(document).ready(function () {
                setupDnnSiteSettings();
                Sys.WebForms.PageRequestManager.getInstance().add_endRequest(function () {
                    setupDnnSiteSettings();
                });
            });

        } (jQuery, window.Sys));
    /*]]>*/</script>
</asp:Panel>