<%@ Control language="vb" Inherits="WillStrohl.Modules.SimpleRedirect.Edit" AutoEventWireup="false" Explicit="True" Codebehind="Edit.ascx.vb" %>
<%@ Register TagPrefix="dnn" TagName="Label" Src="~/controls/LabelControl.ascx" %>
<%@ Register TagPrefix="dnnweb" Assembly="DotNetNuke.Web" Namespace="DotNetNuke.Web.UI.WebControls" %>
<div class="wnsEditView dnnClear">
    <asp:Panel ID="pnlList" runat="server" CssClass="dnnClear">
        <asp:Repeater ID="rptRedirect" runat="server">
            <HeaderTemplate>
                <table class="wnsRedirectGrid dnnGrid">
                    <tr>
                        <td class="dnnGridHeader wnsEditColumn">&nbsp;</td>
                        <td class="dnnGridHeader"><%=GetLocalizedString("Header.RedirectFrom")%></td>
                        <td class="dnnGridHeader"><%=GetLocalizedString("Header.RedirectTo")%></td>
                        <td class="dnnGridHeader wnsEditColumn"><%=GetLocalizedString("Header.Visits")%></td>
                        <td class="dnnGridHeader wnsEditColumn">&nbsp;</td>
                    </tr>
            </HeaderTemplate>
            <ItemTemplate>
                <tr>
                    <td class="dnnGridItem wnsEditColumn">
                        <a href="<%#ReformatUrlForEdit(DataBinder.Eval(Container.DataItem, "RedirectId")) %>"><img src="<%=EditImage %>" alt="<%=GetLocalizedString("Edit.Text") %>" title="<%=GetLocalizedString("Edit.Text") %>" /></a>
                        <a href="<%#ReformatUrlForDelete(DataBinder.Eval(Container.DataItem, "RedirectId")) %>"><img src="<%=DeleteImage %>" alt="<%=GetLocalizedString("Delete.Text") %>" title="<%=GetLocalizedString("Delete.Text") %>" /></a>
                    </td>
                    <td class="dnnGridItem"><%#DataBinder.Eval(Container.DataItem, "RedirectFrom")%></td>
                    <td class="dnnGridItem"><%#DataBinder.Eval(Container.DataItem, "RedirectTo")%></td>
                    <td class="dnnGridItem wnsEditColumn"><%#DataBinder.Eval(Container.DataItem, "Visits")%></td>
                    <td class="dnnGridItem wnsEditColumn">
                        <a href="<%#ReformatUrlForDetails(DataBinder.Eval(Container.DataItem, "RedirectId")) %>" class="wnsDetailsLink"><%=GetLocalizedString("Details.Text") %></a>
                    </td>
                </tr>
            </ItemTemplate>
            <AlternatingItemTemplate>
                <tr>
                    <td class="dnnGridAltItem wnsEditColumn">
                        <a href="<%#ReformatUrlForEdit(DataBinder.Eval(Container.DataItem, "RedirectId")) %>"><img src="<%=EditImage %>" alt="<%=GetLocalizedString("Edit.Text") %>" title="<%=GetLocalizedString("Edit.Text") %>" /></a>
                        <a href="<%#ReformatUrlForDelete(DataBinder.Eval(Container.DataItem, "RedirectId")) %>"><img src="<%=DeleteImage %>" alt="<%=GetLocalizedString("Delete.Text") %>" title="<%=GetLocalizedString("Delete.Text") %>" /></a>
                    </td>
                    <td class="dnnGridAltItem"><%#DataBinder.Eval(Container.DataItem, "RedirectFrom")%></td>
                    <td class="dnnGridAltItem"><%#DataBinder.Eval(Container.DataItem, "RedirectTo")%></td>
                    <td class="dnnGridAltItem wnsEditColumn"><%#DataBinder.Eval(Container.DataItem, "Visits")%></td>
                    <td class="dnnGridAltItem wnsEditColumn">
                        <a href="<%#ReformatUrlForDetails(DataBinder.Eval(Container.DataItem, "RedirectId")) %>" class="wnsDetailsLink"><%=GetLocalizedString("Details.Text") %></a>
                    </td>
                </tr>
            </AlternatingItemTemplate>
            <FooterTemplate>
                </table>
            </FooterTemplate>
        </asp:Repeater>
        <div class="wnsRecordsWarning dnnClear">
            <asp:Label ID="lblNoRecords" runat="server" CssClass="dnnFormMessage dnnFormWarning" />
        </div>
        <asp:LinkButton ID="lnkAddRedirect" runat="server" CssClass="dnnSecondaryAction" CausesValidation="False" />
    </asp:Panel>
    <asp:Panel ID="pnlForm" runat="server" CssClass="dnnClear">
        <div id="dnnEdit" class="dnnForm dnnEditEntry dnnClear">
            <fieldset id="fsRedirect" class="wns-fieldset">
                <div class="dnnFormItem">
                    <dnn:label id="lblRedirectFrom" runat="server" ResourceKey="lblRedirectFrom" ControlName="txtRedirectFrom" Suffix=":" />
                    <asp:TextBox ID="txtRedirectFrom" runat="server" MaxLength="255" CssClass="NormalTextBox dnnFormRequired" ValidationGroup="redirect" /> 
                    <asp:RequiredFieldValidator ID="rfvRedirectFrom" runat="server" ControlToValidate="txtRedirectFrom" Display="Dynamic" CssClass="dnnFormMessage dnnFormError" ValidationGroup="redirect" />
                </div>
                <div class="dnnFormItem">
                    <dnn:label id="lblRedirectTo" runat="server" ResourceKey="lblRedirectTo" ControlName="txtRedirectTo" Suffix=":" />
                    <asp:TextBox ID="txtRedirectTo" runat="server" MaxLength="255" CssClass="NormalTextBox dnnFormRequired" ValidationGroup="redirect" /> 
                    <asp:RequiredFieldValidator ID="rfvRedirectTo" runat="server" ControlToValidate="txtRedirectTo" Display="Dynamic" CssClass="dnnFormMessage dnnFormError" ValidationGroup="redirect" />
                </div>
                <div class="dnnFormItem">
                    <asp:HiddenField ID="hidRedirectId" runat="server"/>
                    <asp:LinkButton ID="lnkSaveRedirect" runat="server" ValidationGroup="redirect" CssClass="dnnPrimaryAction" /> 
                    <asp:LinkButton ID="lnkCancelRedirect" runat="server" CausesValidation="False" CssClass="dnnSecondaryAction" />
                </div>
            </fieldset>
        </div>
    </asp:Panel>
    <hr class="dnnClear" />
    <asp:LinkButton ID="lnkReturn" runat="server" CssClass="dnnSecondaryAction" CausesValidation="False" />
</div>
<script language="javascript" type="text/javascript">/*<![CDATA[*/
    (function ($, Sys) {
        function setupDnnSiteSettings() {
            
        }

        $(document).ready(function () {
            setupDnnSiteSettings();
            Sys.WebForms.PageRequestManager.getInstance().add_endRequest(function () {
                setupDnnSiteSettings();
            });
        });

    } (jQuery, window.Sys));
/*]]>*/</script>